"""
========
TestGen
========

Test code generator code

"""

import os
import sys
import numpy as np
import struct
import csv

class TestGen():

    def __init__(self,*arg): 
        """ 
           TestGen parameters and attributes
        """
        self.pInf = "0x7f800000"
        self.nInf = "0xff800000"
        self.pZero = "0x00000000"
        self.nZero = "0x80000000"
        self.sNaN = "0x7fbfffff"
        self.qNaN = "0x7fffffff"
        self.pNN = "0x00800001"
        self.nNN = "0x80800001"
        self.pSN = "0x00000001"
        self.nSN = "0x80000001"
        self.oper = ["add", "sub", "mul", "div", "sqrt"]

################################## ASSEMBLY ##################################

    def assembly_doubleInput(self, A, B, operation):
        a = "li t1, {a}\n".format(a=A)
        b = "li t2, {b}\n".format(b=B)
        mem = "sw t1, 0(t0)\nflw ft0, 0(t0)\nsw t2, 4(t0)\nflw ft1, 4(t0)\n"
        op = "{op}.s ft2, ft0, ft1\n".format(op=operation)
        return a + b + mem + op + "\n"
        
    def assembly_singleInput(self, A, operation):
        a = "li t1, {a}\n".format(a=A)
        mem = "sw t1, 0(t0)\nflw ft0, 0(t0)\n"
        op = "{op}.s ft2, ft0\n".format(op=operation)
        return a + mem + op + "\n"

    def assembly_tests(self, operations):
        a = [self.pInf, self.nInf, self.pZero, self.nZero, self.sNaN, self.qNaN, self.pNN, self.nNN, self.pSN, self.nSN]
        b = [self.pInf, self.nInf, self.pZero, self.nZero, self.sNaN, self.qNaN, self.pNN, self.nNN, self.pSN, self.nSN]

        f = open("result/test.s", "w")

        f.write(".global _start\n" \
                "_start:\n" \
                "li t0, 0x20000004\n\n"
               )
  
        for operation in operations:
            f.write(20*"#" + operation.upper() + 20*"#" + 2*"\n")
            if operation != "sqrt":
                for aop in a:
                    for bop in b:
                        f.write(self.assembly_doubleInput(aop, bop, operation))
            else:
                for aop in a:
                    f.write(self.assembly_singleInput(aop, operation))

        print("Generation complete, generated {x} assembly tests!".format(x=(len(a)**2 + len(a))))

        f.close()

################################## CHISEL ##################################

    def read_file(self, fname):
        data = []
        with open("csv/{name}.csv".format(name=fname), 'r') as ifile:
            reader = csv.reader(ifile)
            for row in reader:
                data.append(row)
             
        op = data[0][0]
        a = data[0][1:]
        b = []
        result = []

        for row in data:
            if row[0] != op:
                b.append(row[0])
                result.append(row[1:])
                
        return op, a, b, result

    def chisel_pretext(self, blockname):
        return "// NOTE: This file is autogenerated with a-core_thesydekick/Entities/ACoreChip/ACoreChip/FGEN/TestGen.py \n\n" \
               "package {bnlw} \n\n" \
               "import chisel3._ \n" \
               "import chiseltest._ \n" \
               "import org.scalatest.flatspec.AnyFlatSpec \n" \
               "import a_core_common._\n\n" \
	       "class {bn}Spec extends AnyFlatSpec with ChiselScalatestTester {{\n\n".format(bnlw="acorebase", bn=blockname)

    def chisel_testtext(self, op):
        return "  it should \"do special case tests for {op}\" in {{\n" \
               "    test(new SPFPBlock(XLEN=32)).withAnnotations(Seq(WriteVcdAnnotation)) {{ c =>\n\n" \
               "      c.io.op poke SPFPOp.{op}_S\n" \
               "      c.io.rm poke RoundingMode.RNE\n\n".format(op=op)

    def chisel_doubleInput(self, A, B, result):
        a = 	"      c.io.a poke \"h{a}\".U\n".format(a=A)
        b = 	"      c.io.b poke \"h{b}\".U\n".format(b=B)
        out = 	"      c.io.out expect \"h{res}\".U\n".format(res=result)
        return a + b + out + "\n"
        
    def chisel_singleInput(self, A, result):
        a = 	"      c.io.a poke \"h{a}\".U\n".format(a=A)
        out = 	"      c.io.out expect \"h{res}\".U\n".format(res=result)
        return a + out + "\n"

    def chisel_tests(self, blockname, csv_files):
        f = open("result/{bn}Spec_AutoGen.scala".format(bn=blockname), "w")

        f.write(self.chisel_pretext(blockname))

        count = 0

        for fname in csv_files:
            [op, a, b, result] = self.read_file(fname)

            f.write("\n" + 20*"/" + op + 20*"/" + 2*"\n")
            f.write(self.chisel_testtext(op))

            if op != "FSQRT":
                for i in range(len(a)):
                   for j in range(len(b)):
                        f.write(self.chisel_doubleInput(a[i], b[j], result[i][j]))
                count += (i+1)*(j+1)
            else:
                for i in range(len(a)):
                    f.write(self.chisel_singleInput(a[i], result[0][i]))
                count += i+1

            f.write("    }\n  }\n")
        f.write("}\n")

        print("Generation complete, generated {x} chisel tests!".format(x=count))

        f.close()


################################## MAIN ##################################

if __name__=="__main__":
    #Data under test
    DUT = ["fadd", "fsub", "fmul", "fdiv", "fsqrt"]
    gen = TestGen()

    gen.assembly_tests(DUT)
    gen.chisel_tests("SPFPBlock", DUT)

